安基网 首页 安全 安全学院 查看内容

吃惊,大神级别的黑客教你pwn二进制安全环境搭建!

2020-3-25 20:45| 投稿: xiaotiger |来自: 互联网


免责声明:本站系公益性非盈利IT技术普及网,本文由投稿者转载自互联网的公开文章,文末均已注明出处,其内容和图片版权归原网站或作者所有,文中所述不代表本站观点,若有无意侵权或转载不当之处请从网站右下角联系我们处理,谢谢合作!

摘要: Ubuntu换源由于Ubuntu官方的源是国外的,所以速度很慢,要把它换成国内的镜像站,那样,不管是更新、还是安装软件,都是比较快的。网易源http://mirrors.163.com/中科大源http://mirrors.ustc.edu.cn/华科大源http://mirror.hust.edu.cn/浙大源http://mirrors.zju.edu.cn/每个开源镜像站都有介绍不同版 ...

Ubuntu

换源

由于Ubuntu官方的源是国外的,所以速度很慢,要把它换成国内的镜像站,那样,不管是更新、还是安装软件,都是比较快的。

网易源
http://mirrors.163.com/
中科大源
http://mirrors.ustc.edu.cn/
华科大源
http://mirror.hust.edu.cn/
浙大源
http://mirrors.zju.edu.cn/

每个开源镜像站都有介绍不同版本的Linux的源的使用方式,访问上述网址就行了。首先找到/etc/apt下的sources.list,先将其备份一个,然后将上述镜像站的源替换sources.list里的官方源并保存。然后执行下面两条命令:

sudo apt-get update 更新源

sudo apt-get upgrade 更新软件

安装open-vm-tools

前面安装的是VMware提供的VMware Tools,但是不能自适应客户机也不能进行文件复制,相当于没有安装,哈哈哈。记得之前有一个工具可以替代VMware Tools,名字也想不起来了就上网搜了下,是open-vm-tools.而且当你安装VMware Tools的时候也会提醒你安装open-vm-tools.安装前先将VMware Tools卸载。Ubuntu14.04及以上版本,都建议安装这个工具。安装使用如下命令:

#desktop

sudo apt-get install open-vm-tools

sudo apt-get install open-vm-tools-desktop

#server or headless

sudo apt-get install open-vm-tools

安装搜狗输入法

这个也很简单,先下载Linux版的deb包,按照自己所安装系统的位数下载,然后运行下面一条命令:

sudo dpkg -i deb包的名字

安装vim

本来一条命令就可以安装成功,但还是出现了问题,依旧是依赖问题

sudo apt-get install vim

Pwn环境搭建

基本工具

· gdb+peda+pwndbg、gcc、Pwntools、Binutils

· Capstone、gcc-multilib、socat、rp++、readelf

· ROPgaget、libc-database、objdump、file、string、checksec

Pwntools是一个CTF框架和漏洞利用开发库,它使用Python编写的,由rapid设计并维护,设计这个框架的目的是为了让使用者简单快速的编写exploit。对Pwntools支持最好的是64bits的Ubuntu LTE Realease(12.04、14.04、16.04),所以我选择了在Ubuntu16.04下安装这个框架,Python环境是Python2.7。但是绝大多数的功能也支持Debian, Arch, FreeBSD, OSX, 等等。安装Pwntools成功的前提是安装了git、pip、Binutils、Capstone、Python-Dev等库和工具。

安装pip

pip是Python的一个包管理工具,用于安装和卸载Python的扩展模块。如果你使用的Python 2 >=2.7.9或Python 3 >=3.4并且从python.org下载,那么pip已经安装了,但是需要升级pip

#安装pip

sudo apt-get update #更新源

sudo apt-get install python-pip #安装pip,可能会有依赖问题,记不清了

pip --version #查看pip版本,确认是否安装成功

#升级pip

sudo pip install --upgrade pip #Linux or MacOS

python -m pip install -U pip #windows

pip常用命令

pip --help #查看帮助菜单

pip install packageName #安装新的python包

pip uninstall packageName #卸载python包

pip search packageName #寻找python包

安装git(分布式版本控制系统)

Git是一个开源的分布式版本控制系统,可以有效、高速的处理从很小到非常大的项目版本管理。Git 是 Linus Torvalds 为了帮助管理 Linux 内核开发而开发的一个开放源码的版本控制软件(百度百科)。 通过这个工具,我们可以下载和上传一些开源软件的源代码,非常方便。这些代码都是保存在Github上的仓库中。

Github与Git的区别 Git,开发者将源代码存入名叫"Git 仓库"的资料库中并加以使用。而 GitHub 则是在网络上提供 Git 仓库的一项服务。也就是说,GitHub 上公开的软件源代码全都由 Git 进行管理。理解 Git,是熟练运用 GitHub 的关键所在。

#安装git工具

sudo apt-get install git

Capstone

Capstone介绍 Capstone是一个反汇编框架,它的目标是成为最好的反汇编引擎,它是为安全社区中的研究人员进行二进制分析和逆向提供服务的。Core (Arm, Arm64, M68K, Mips, PPC, Sparc, SystemZ, X86, X86_64, XCore) + bindings (Python, Java, Ocaml, PowerShell)

#安装Capstone

git clone http://github.com/aquynh/capstone #下载Capstone源码到本地

cd capstone

make #编译源文件

sudo make install #编译并安装

安装Binutils

Binutils简介 GNU Binutils 是一组开发工具,包括连接器,汇编器和其他用于目标文件和档案的工具。包括下列程序: addr2line, ar, as, c++filt, gprof, ld, nm, objcopy, objdump, ranlib, readelf, size, strings 和 strip。下载链接

Ubuntu16.04默认是安装了Binutils的,所以如果版本太老了可以选择更新一下。外国架构的组装(例如,在Mac OS X上装配Sparc shell)需要安装跨编译的binutils版本。

编译安装法

wget http://ftp.gnu.org/gnu/binutils/binutils-2.25.1.tar.bz2

tar -xvf binutils-2.25.1.tar.bz2

mkdir -v ../binutils-build #binutils官方推荐编译binutils要和源码分离

cd ../binutils-build

../binutils-2.20/configure --prefix=/tools

make #编译

make install #编译并安装


pwntools-binutils安装

git clone https://github.com/Gallopsled/pwntools-binutils

cd ubuntu

chmod +x install_all.sh

./install_all.sh arm #your architecture

安装Python-Dev(Python Development Headers)

Python-Dev介绍 python-dev或python-devel称为是python的开发包,其中包括了一些用C/Java/C#等编写的python扩展在编译的时候依赖的头文件等信息。比如我们在编译一个用C语言编写的python扩展模块时,因为里面会有#include等这样的语句,因此我们就需要先安装python-devel开发包。

一些Pwntools的Python依赖项需要本地扩展,所以必须要安装Python-Dev.

apt-get install python-dev

安装Pwntools

github下载安装

git clone https://github.com/Gallopsled/pwntools

cd pwntools

python setup.py install

pip安装

apt-get update

#可以看到有些前面已经装过了,这是我复制pwntools手册上的

apt-get install python2.7 python-pip python-dev git libssl-dev libffi-dev build-essential

pip install --upgrade pip

pip install --upgrade pwntools

如果没报错,进入python终端,输入import pwn,然后回车,没报错应该就是安装好了 现在尝试一下pwntools的asm功能:

>>> pwn.asm("xor eax,eax")

'1xc0'

如果有正确输出,即说明这个功能是可以用的,到这里就算安装完成。

gdb+peda+pwndbg安装

gdb介绍 GDB(GNU Debugger)GNU开发的Unix/Linux下的调试工具。其功能强大,现描述如下: GDB主要帮忙你完成下面四个方面的功能: 1.启动你的程序,可以按照你的自定义的要求随心所欲的运行程序。 2.可让被调试的程序在你所指定的调置的断点处停住。(断点可以是条件表达式) 3.当程序被停住时,可以检查此时你的程序中所发生的事。 4.动态的改变你程序的执行环境。 gdb不同于windows下的ollydbg和windbg,它是命令行下的工具,没有图形界面,通过输入命令与它交互,来调试程序,查看程序的运行过程,这一点和windbg有点相似。也是很多致力于安全研究、漏洞发现的人的一个神器。

Ubuntu16.04是默认安装了gdb的,可以使用gdb --version查看gdb的版本,如果没有安装可以使用下面一条命令进行安装,也可以编译安装。

sudo apt-get install gdb

peda介绍 peda全称是Python Exploit Development Assistance for GDB。PEDA是为GDB设计的一个强大的插件它提供了很多人性化的功能,比如高亮显示反汇编代码、寄存器、内存信息,提高了debug的效率。同时,PEDA还为GDB添加了一些实用新的命令,比如checksec可以查看程序开启了哪些安全机制等等。它是用Python写的一个工具,可以辅助编写exp,运行在Unix/Linux系统上。

#安装peda

git clone https://github.com/longld/peda.git ~/peda

echo "source ~/peda/peda.py" >> ~/.gdbinit

echo "DONE! debug your program with gdb and enjoy"

peda也可以通过pip安装

sudo apt-get install pip

pwndbg介绍 Pwndbg是一个Python模块,它直接加载到GDB中,并提供了一套实用工具和一组辅助工具来绕过GDB的所有cruft,并将粗糙的边缘平滑掉。过去的许多其他项目(如gdbinit、PEDA)和现在(例如GEF)的存在填补了这些空白。它们都提供了优秀的经验和优秀的特性——但是它们很难扩展(有些是未维护的,所有的都是单个100KB、200KB或300KB文件)。Pwndbg的存在不仅是为了取代它的所有前辈,而且还有一个快速运行的干净的实现。

Pwndbg支持最好的环境是: Ubuntu14.04 and GDB7.7 Ubuntu16.04 and GDB7.11

#安装Pwndbg

git clone https://github.com/pwndbg/pwndbg

cd pwndbg

./setup.sh

这些工具的用法打算另写一篇文章,不然这篇文章实在是太长了。

安装gcc-multilib

gcc-multilib gcc-multilib是Debian的64位系统下运行32位程序的一个库,装了这个库就可以运行32位的程序了。

#安装命令

sudo apt-get install gcc-multilib 或者

sudo aptitude install gcc-multilib

socat

socat socat是一个多功能的网络工具,名字来由是" Socket CAT",可以看作是netcat的加强版,socat是两个独立数据通道之间的双向数据传输的继电器。这些数据通道包含文件、管道、设备(终端或调制解调器等)、插座(Unix,IP4,IP6 - raw,UDP,TCP)、SSL、SOCKS4客户端或代理CONNECT。Socat支持广播和多播、抽象Unix sockets、Linux tun/tap、GNU readline 和 PTY。它提供了分叉、记录和进程间通信的不同模式。多个选项可用于调整socat和其渠道,Socat可以作为TCP中继(一次性或守护进程),作为一个守护进程基于socksifier,作为一个shell Unix套接字接口,作为IP6的继电器,或面向TCP的程序重定向到一个串行线。socat的主要特点就是在两个数据流之间建立通道;且支持众多协议和链接方式:ip, tcp, udp, ipv6, pipe,exec,system,open,proxy,openssl,socket等。(文档英文的看起来太困难,这是别人写的,也不知道对不对,以后)

Ubuntu16.04下默认安装有,如果没有,需要安装的话,看了别人的文章,好像要下载源码编译安装。

安装rp++

rp++ rp++是一种完全用c++编写的工具,目的是在PE/Elf/Mach-O(不支持FAT二进制文件)x86/x64二进制文件中找到ROP序列。它是开源的,已经在几个操作系统上测试过:Debian / Windows 7 / FreeBSD / Mac OSX Lion(10.7.3)。此外,它是x64兼容的。我差点忘了,它同时处理英特尔和英特尔。


#运行

chmod +x rp-lin-x64

./rp-lin-x64

安装ROPgadget

ROPgadget介绍 这个工具可以让你在二进制文件上搜索的小工具,以方便你的ROP利用。ROPgadget支持x86、x64、ARM、ARM64、PowerPC、SPARC和MIPS体系结构的ELF/PE/Mach-O格式。从版本5开始,ROPgadget有一个新的核心,它是用Python的Capstone disassembly框架编写的,用于gadget搜索引擎——旧版本可以在存档目录中找到,但它不会被维护。

安装ROPgadget之前需要先安装Capstone,这个反汇编框架之前已经安装过了。

#方法一

#安装过capstone后,ROPgadget可以作为一个单独的工具使用

ROPgadget.py

#方法二

#安装到Python的站点包库中,并且加入环境变量中

python setup.py install

ROPgadget

#方法三

#用pip安装

pip install ropgadget

ROPgadget

libc

libc-database介绍 libc是Linux下的ANSI C的函数库。ANSI C是基本的C语言函数库,包含了C语言最基本的库函数。libc-database是github上的一个仓库,可以进行服务器上所用函数库版本的识别。

这里还有一个更全的,是一个网站。libcdb.com

写到这总算告一段落了,如果后期还有更好的工具,我会补充,就先到这吧。



小编推荐:欲学习电脑技术、系统维护、网络管理、编程开发和安全攻防等高端IT技术,请 点击这里 注册账号,公开课频道价值万元IT培训教程免费学,让您少走弯路、事半功倍,好工作升职加薪!

本文出自:https://www.toutiao.com/i6808024675931652611/

免责声明:本站系公益性非盈利IT技术普及网,本文由投稿者转载自互联网的公开文章,文末均已注明出处,其内容和图片版权归原网站或作者所有,文中所述不代表本站观点,若有无意侵权或转载不当之处请从网站右下角联系我们处理,谢谢合作!


鲜花

握手

雷人

路过

鸡蛋

相关阅读

最新评论

 最新
返回顶部